function out = momfunc_Equidep_blk( x , q , blks, type)
   M = max(blks); [T,~] = size(x); Q = length(q); ell = Q+type;

    % Store results
        intra = zeros((Q+type)*M,1); inter = zeros((Q+type),1);
        blSize = nan(M,1); blStart = ones(M,1);
    % Sort the data according to blocks
        [~,IX] = sort(blks);
        x = x(:,IX);
    % Determine size of every block
        for i = 1:M
            blSize(i) = sum(blks == i);
        end
    % Starting index of every block
        for i = 2:M
            blStart(i) = sum(blSize(1:(i-1)))+1;
        end

    % Intragroup dependence measures
%     if type == 1
            for i = 1:M
            for j = blStart(i):(blStart(i)+blSize(i)-2)
                for k = j+1:(blStart(i)+blSize(i)-1)                    
                    intra(1+ell*(i-1)) = intra(1+ell*(i-1)) + sum(   mSrho( x(:,j), x(:,k) )      )/T ;
                    for qq = 1:Q
                        intra(1+qq+ell*(i-1)) = intra(1+qq+ell*(i-1)) + sum(   mQdep( x(:,j), x(:,k), q(qq) ) )/T ;
                    end
                end 
            end
            intra(1+ell*(i-1):ell+ell*(i-1)) = intra(1+ell*(i-1):ell+ell*(i-1))/(blSize(i)*(blSize(i)-1)/2);
            end

    out = intra;
 
end



